#ifndef INCLUDE_RECORDING_OPTION_H
#define INCLUDE_RECORDING_OPTION_H

// }[W0`MARGIN_MAXb܂Őݒ\
// (I}[W-MARGIN_MAX`MARGIN_MAXb)
#define MARGIN_MAX 600
#define MARGIN_DEFAULT INT_MIN

// ^̗Dx
enum {
    PRIORITY_DEFAULT,
    PRIORITY_LOWEST,
    PRIORITY_LOW,
    PRIORITY_NORMAL,
    PRIORITY_HIGH,
    PRIORITY_HIGHEST,
    PRIORITY_MOD
};

// ^~̓
enum {
    ON_STOPPED_DEFAULT,     // ftHgݒ̓s
    ON_STOPPED_NONE,        // Ȃ
    ON_STOPPED_CLOSE,       // TVTestI
    ON_STOPPED_SUSPEND,     // VXeTXyh
    ON_STOPPED_HIBERNATE,   // VXex~
    ON_STOPPED_S_NONE,      // TVTestҋ@->Ȃ
    ON_STOPPED_S_CLOSE,     // TVTestҋ@->TVTestI
    ON_STOPPED_S_SUSPEND,   // TVTestҋ@->VXeTXyh
    ON_STOPPED_S_HIBERNATE, // TVTestҋ@->VXex~
    ON_STOPPED_MAX
};

struct RECORDING_OPTION {
    int startMargin;            // ^Jn}[W[b]
    int endMargin;              // ^I}[W[b]
    BYTE priority;              // ^̗Dx(<PRIORITY_MOD:邾x)
    BYTE onStopped;             // ^~̓
    TCHAR saveDir[MAX_PATH];    // ۑfBNg
    TCHAR saveName[MAX_PATH];   // ۑt@C
    int startTrim;              // ^Jn̒x[b]
    int endTrim;                // ^ȊO|[b]
    bool IsViewOnly() const { return priority < PRIORITY_MOD; }
    bool FromString(LPCTSTR str);
    void LoadDefaultSetting(LPCTSTR fileName);
    void ToString(LPTSTR str) const;
    void SaveDefaultSetting(LPCTSTR fileName) const;
    void SetEmpty(bool fViewOnly);
    void SetDefault(bool fViewOnly);
    void ApplyDefault(const RECORDING_OPTION &defaultOption);
    INT_PTR DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, bool hasDefault, const RECORDING_OPTION *pDefaultOption = NULL);
};

#endif // INCLUDE_RECORDING_OPTION_H
